<template>
  <div v-if="$store.state.auth">
    <v-card flat color="white">
      <v-card-title>散燈維修
        <v-spacer></v-spacer>
        <v-text-field v-model="search" append-icon="search" label="Search" single-line hide-details></v-text-field>
      </v-card-title>
      <v-divider class="mx-2" inset vertical></v-divider>
      <v-spacer></v-spacer>

      <!-- <v-dialog v-model="dialog_new" max-width="500px">
        <v-btn slot="activator" color="primary" dark @click="newDamaged">New Item</v-btn>
        <v-card>
          <v-card-title>
            <span class="headline">新巡燈</span>
          </v-card-title>

          <v-card-text>
            <v-container grid-list-md>
              <v-layout wrap>
                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.source" label="來源"></v-text-field>
                </v-flex>

                <v-flex xs12 lg6>
                  <v-menu ref="menu2" :close-on-content-click="false" v-model="menu2" :nudge-right="40" :return-value.sync="editedItem.repairDate"
                    lazy transition="scale-transition" offset-y full-width min-width="290px">
                    <v-text-field slot="activator" v-model="editedItem.repairDate" label="出Order日期" prepend-icon="event" readonly></v-text-field>
                    <v-date-picker v-model="date" @input="$refs.menu2.save(date)"></v-date-picker>

                  </v-menu>
                </v-flex>

                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.location" label="位置"></v-text-field>
                </v-flex>

                <v-flex xs12 lg6>
                  <v-select :items="items_type" label="燈類型"></v-select>
                </v-flex>

                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.lampNo" label="燈號"></v-text-field>
                </v-flex>

                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.district" label="地區"></v-text-field>
                </v-flex>


              </v-layout>
            </v-container>
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue darken-1" flat @click.native="close">Cancel</v-btn>
            <v-btn color="blue darken-1" flat @click.native="addSave">Save</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog> -->

      <v-dialog v-model="confirm" max-width="290">
        <v-card>
          <v-card-title class="headline"> {{action == 'repair' ? "確定已維修" : action == 'delete' ? "確定刪除" : ''}}</v-card-title>
          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn color="green darken-1" flat="flat" @click="confirm = false; action = ''">
              不確定
            </v-btn>

            <div v-if="action == 'repair'">
              <v-btn color="green darken-1" flat="flat" @click="repair(editedItem)">
                確定
              </v-btn>
            </div>
            <div v-else-if="action == 'delete'">
              <v-btn color="green darken-1" flat="flat" @click="selectedDelete(editedItem)">
                確定
              </v-btn>
            </div>
          </v-card-actions>
          <v-list-tile v-for="(value, i) in editedItem" :key="i">
            <v-list-tile-content>
              <v-list-tile-title v-text="editedItem[i].lampNo"></v-list-tile-title>
            </v-list-tile-content>
          </v-list-tile>

        </v-card>
      </v-dialog>

      <!-- <v-dialog v-model="confirm_delete" max-width="290">
        <v-card>
          <v-card-title class="headline">確定刪除</v-card-title>
          <v-list-tile v-for="(value, i) in editedItem" :key="i">
            <v-list-tile-content>
              <v-list-tile-title v-text="editedItem[i].lampNo"></v-list-tile-title>
            </v-list-tile-content>
          </v-list-tile>
          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn color="green darken-1" flat="flat" @click="confirm_delete = false">
              不確定
            </v-btn>

            <v-btn color="green darken-1" flat="flat" @click="deleteSelected(editedItem)">
              確定
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog> -->


      <v-dialog v-model="dialog" max-width="500px">
        <v-card>
          <v-card-title>
            <span class="headline">{{ formTitle }}</span>
          </v-card-title>

          <v-card-text>
            <v-container grid-list-md>
              <v-layout wrap>
                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.source" label="來源" disabled></v-text-field>
                </v-flex>
                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.orderDate" label="出 Order 日期" disabled></v-text-field>
                </v-flex>
                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.location" label="位置" disabled></v-text-field>
                </v-flex>
                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.district" label="地區" disabled></v-text-field>
                </v-flex>
                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.type" label="燈類型" disabled></v-text-field>
                </v-flex>
                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.lampNo" label="燈號" disabled></v-text-field>
                </v-flex>
                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.repairStaff" label="維修同事" disabled></v-text-field>
                </v-flex>
                <!-- <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.callOut" label="callOut" disabled></v-text-field>
                </v-flex> -->
                <!-- <v-flex xs12 lg6>
                  <v-menu ref="menu2" :close-on-content-click="false" v-model="menu2_ArriveData" :nudge-right="40" :return-value.sync="editedItem.arriveDate"
                    lazy transition="scale-transition" offset-y full-width min-width="290px">
                    <v-text-field slot="activator" v-model="editedItem.repairDate" label="到場日期" prepend-icon="event" readonly></v-text-field>
                    <v-date-picker v-model="date" @input="$refs.menu2.save(date)"></v-date-picker>

                  </v-menu>
                </v-flex>
                <v-flex xs12 lg6>
                  <v-menu ref="menu" :close-on-content-click="false" v-model="menu2" :nudge-right="40" :return-value.sync="editedItem.arriveTime" lazy transition="scale-transition"
                    offset-y full-width max-width="290px" min-width="290px">
                    <v-text-field slot="activator" v-model="editedItem.arriveTime" label="到場時間" prepend-icon="access_time" readonly></v-text-field>
                    <v-time-picker v-if="menu2" v-model="time" @change="$refs.menu.save(time)"></v-time-picker>
                  </v-menu>
                </v-flex>
                <v-flex xs12 lg6>
                  <v-menu ref="menu2" :close-on-content-click="false" v-model="menu2" :nudge-right="40" :return-value.sync="editedItem.finishDate"
                    lazy transition="scale-transition" offset-y full-width min-width="290px">
                    <v-text-field slot="activator" v-model="editedItem.repairDate" label="完工日期" prepend-icon="event" readonly></v-text-field>
                    <v-date-picker v-model="date" @input="$refs.menu2.save(date)"></v-date-picker>

                  </v-menu>
                </v-flex>
                <v-flex xs12 lg6>
                  <v-menu ref="menu" :close-on-content-click="false" v-model="menu2" :nudge-right="40" :return-value.sync="editedItem.finishTime" lazy transition="scale-transition"
                    offset-y full-width max-width="290px" min-width="290px">
                    <v-text-field slot="activator" v-model="editedItem.finishTime" label="到場時間" prepend-icon="access_time" readonly></v-text-field>
                    <v-time-picker v-if="menu2" v-model="time" @change="$refs.menu.save(time)"></v-time-picker>
                  </v-menu>
                </v-flex> -->
                <v-flex xs12 lg6>
                  <v-text-field v-model="editedItem.repairStaff" label="維修同事"></v-text-field>
                </v-flex>
                <div v-if="editedItem.repaired == false" class="text-xs-center">
                  <v-btn round color="primary" dark @click="confirm = true">已維修</v-btn>
                </div>
              </v-layout>
            </v-container>
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue darken-1" flat @click.native="close">Cancel</v-btn>
            <v-btn color="blue darken-1" flat @click.native="save">Save</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-card>
    <div class="text-xs-center pt-2">
      <v-btn color="primary" @click.native="clickRepair(selected, true)">刪除</v-btn>
      <v-btn color="primary" @click.native="clickRepair(selected, false)">確定維修</v-btn>
    </div>
    <v-data-table :headers="headers" :items="$store.state.repairment" :pagination.sync="pagination" :search="search"
      v-model="selected" item-key="name" select-all class="elevation-1">
      <template slot="headerCell" slot-scope="props">
        <v-tooltip bottom>
          <span slot="activator">
            {{ props.header.text }}
          </span>
          <span>
            {{ props.header.text }}
          </span>
        </v-tooltip>
      </template>
      <template slot="headers" slot-scope="props">
        <tr>
          <th>
            <v-checkbox :input-value="props.all" :indeterminate="props.indeterminate" primary hide-details
              @click.native="toggleAll"></v-checkbox>
          </th>
          <th v-for="header in props.headers" :key="header.text" :class="['column sortable', pagination.descending ? 'desc' : 'asc', header.value === pagination.sortBy ? 'active' : '']"
            @click="changeSort(header.value)">
            <v-icon small>arrow_upward</v-icon>
            {{ header.text }}
          </th>
        </tr>
      </template>
      <template slot="items" slot-scope="props">
        <td>
          <v-checkbox v-model="props.selected" primary hide-details></v-checkbox>
        </td>
        <td class="text-xs-left">{{ props.item.lampNo }}</td>
        <td class="justify-center layout px-0">
          <div v-if="props.item.repaired == false" class="text-xs-center">
            <v-btn round color="primary" dark @click="clickRepair(props.item, false)">確定維修</v-btn>
          </div>
        </td>
        <!-- <td>{{ props.item.source }}</td> -->
        <!-- <td class="text-xs-left">{{ props.item.orderDate }}</td> -->
        <td class="text-xs-left">{{ props.item.location }}</td>
        <!-- <td class="text-xs-left">{{ props.item.district }}</td> -->
        <!-- <td class="text-xs-right">{{ props.item.type }}</td> -->

        <!-- <td class="text-xs-right">{{ props.item.callOut }}</td> -->
        <!-- <td class="text-xs-right">{{ props.item.repairStaff }}</td> -->
        <!-- <td class="text-xs-left">{{ props.item.repaired }}</td> -->
        <!-- <td class="justify-center layout px-0">
          <v-icon small class="mr-2" @click="editItem(props.item)">
            edit
          </v-icon>
        </td> -->

      </template>
      <template slot="no-data">
        <v-btn color="primary" @click="initialize">Reset</v-btn>
      </template>

    </v-data-table>

  </div>
</template>

<script>
  import moment from 'moment';
  import axios from 'axios';

  export default {
    data: () => ({
      //dialog_new: false,
      search: '',
      pagination: {
        sortBy: 'name'
      },
      selected: [],
      items_type: ['路燈', '村燈', '左行燈', '路牌燈', '飛天線', '拆天線', '其他'],
      dialog: false,
      confirm: false,
      action: '',
      headers: [{
          text: '燈號',
          value: 'lampNo'
        },
        {
          text: '已維修',
          value: 'name'
        },
        // {
        //   text: '來源',
        //   value: 'source',
        //   align: 'left',
        // },
        // {
        //   text: '出Order日期',
        //   value: 'orderDate'
        // },
        {
          text: '位置',
          value: 'location'
        },
        // {
        //   text: '地區',
        //   value: 'district'
        // },
        // {
        //   text: '燈類型',
        //   value: 'type'
        // },

        // {
        //   text: 'Call Out',
        //   value: 'callOut'
        // },
        // {
        //   text: '維修同事',
        //   value: 'repairStaff'
        // },
      ],
      editedIndex: -1,
      editedItem: [],
      defaultItem: {
        value: false,
        lampNo: '',
        contrNo: '',
        location: '',
        district: '',
        source: '',
        orderDate: '',
        finishDate: moment().format('YYYY-MM-DD'),
        finishTime: moment().format('HH:MM'),
        repairStaff: null
      },
      date: moment().format('YYYY-MM-DD'),
      menu2: false
    }),
    computed: {
      formTitle() {
        return this.editedIndex === -1 ? 'New Item' : 'Edit Item'
      }
    },
    watch: {
      dialog(val) {
        val || this.close()
      }
    },
    created() {
      this.initialize()
    },
    methods: {
      async initialize() {
        // await this.$store.dispatch('setDamaged');
        // await this.$store.dispatch('setAllInfo');
        this.$store.dispatch('init');
        await this.$store.dispatch('setRepairment');
      },
      editItem(item) {
        this.editedIndex = this.$store.state.allInfo.indexOf(item)
        this.editedItem = Object.assign({}, item)
        this.dialog = true
      },
      toggleAll() {
        if (this.selected.length) this.selected = []
        else this.selected = this.$store.state.repairment.slice()
      },
      changeSort(column) {
        if (this.pagination.sortBy === column) {
          this.pagination.descending = !this.pagination.descending
        } else {
          this.pagination.sortBy = column
          this.pagination.descending = false
        }
      },

      clickRepair(item, del) {
        del ? this.action = 'delete' : this.action = 'repair';
        this.confirm = true;
        if (!item.length) {
          this.editedItem = [];
          this.editedItem[0] = item;
        } else {
          this.editedItem = item;
        }
      },
      async repair(repairItem) {
        if (this.$store.state.auth) {
          for (let i = 0; i < repairItem.length; i++) {
            const url = 'http://192.168.10.231:5000/http://192.168.10.231:46080/repairment/repaired';
            //const url = "http://59.148.251.104:34709/repairment/repaired";
            let repairData = {
              id: repairItem[i].id,
              repaired: true,
              lampNo: repairItem[i].lampNo,
              district: this.$store.state.auth.username
            }
            const opt = {
              method: 'POST',
              headers: {
                'content-type': 'application/json',
                //'X-Requested-With': 'XMLHttpRequest'
              },
              data: JSON.stringify(repairData),
              url,
            }
            const response = await axios(opt);
            this.confirm = false;
            this.action = '';
            this.editItem = [];
            await this.initialize();
          }
        } else {
          alert('Please login first');
          this.$router.push('index')
        }


      },
      // newDamaged() {
      //   this.dialog_new = true;
      // },
      close() {
        //this.dialog_new = false;
        this.dialog = false;
        setTimeout(() => {
          this.editedItem = Object.assign({}, this.defaultItem)
          this.editedIndex = -1
        }, 300)
      },
      async save() {
        if (this.editedIndex > -1) {
          await Object.assign(this.$store.state.allInfo[this.editedIndex], this.editedItem);
        } else {
          this.$store.state.allInfo.push(this.editedItem)
        }
        this.close()
      },
      async selectedDelete(repairItem) {
        if (this.$store.state.auth) {
          for (let i = 0; i < repairItem.length; i++) {
            const url = 'http://192.168.10.231:5000/http://192.168.10.231:46080/repairment/delete';
            //const url = "http://59.148.251.104:34709/repairment/repaired";
            let repairData = {
              id: repairItem[i].id,
              deleted: true,
              lampNo: repairItem[i].lampNo,
              district: this.$store.state.auth.username
            }
            const opt = {
              method: 'POST',
              headers: {
                'content-type': 'application/json',
                //'X-Requested-With': 'XMLHttpRequest'
              },
              data: JSON.stringify(repairData),
              url,
            }
            const response = await axios(opt);
            this.confirm = false;
            this.action = '';
            this.editItem = [];
            await this.initialize();
          }
        } else {
            alert('Please login first');
            this.$router.push('index')
        }
      }
    }
  }

</script>
